{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.MediaLive.Types.H264RateControlMode
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.MediaLive.Types.H264RateControlMode
  ( H264RateControlMode
      ( ..,
        H264RateControlMode_CBR,
        H264RateControlMode_MULTIPLEX,
        H264RateControlMode_QVBR,
        H264RateControlMode_VBR
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

-- | H264 Rate Control Mode
newtype H264RateControlMode = H264RateControlMode'
  { fromH264RateControlMode ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern H264RateControlMode_CBR :: H264RateControlMode
pattern H264RateControlMode_CBR = H264RateControlMode' "CBR"

pattern H264RateControlMode_MULTIPLEX :: H264RateControlMode
pattern H264RateControlMode_MULTIPLEX = H264RateControlMode' "MULTIPLEX"

pattern H264RateControlMode_QVBR :: H264RateControlMode
pattern H264RateControlMode_QVBR = H264RateControlMode' "QVBR"

pattern H264RateControlMode_VBR :: H264RateControlMode
pattern H264RateControlMode_VBR = H264RateControlMode' "VBR"

{-# COMPLETE
  H264RateControlMode_CBR,
  H264RateControlMode_MULTIPLEX,
  H264RateControlMode_QVBR,
  H264RateControlMode_VBR,
  H264RateControlMode'
  #-}
